function A = FFmatrix_fread(filename)
% Copyright 2020 Tony Stillfjord
%
% This file is part of BST20_CODE.
% 
% BST20_CODE is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% BST20_CODE is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with BST20_CODE.  If not, see <http://www.gnu.org/licenses/>.
%
file = fopen(filename, 'r');
for j = 1:3
    fgets(file); % skip first three lines
end

line1 = fscanf(file, '%d', 4);

N = line1(1);
m = line1(2);
sym = line1(3);
nnz = line1(4);
nnz_sym = nnz;

vals = zeros(nnz*(1+sym), 1);
rows = zeros(nnz*(1+sym), 1);
cols = zeros(nnz*(1+sym), 1);

for j = 1:nnz
    line = fscanf(file, '%f', 3);
    rows(j) = line(1);
	cols(j) = line(2);
	vals(j) = line(3);
    if sym && (rows(j) ~= cols(j))
        nnz_sym = nnz_sym + 1;
        rows(nnz_sym) = cols(j);
        cols(nnz_sym) = rows(j);
        vals(nnz_sym) = vals(j);
    end
end

if sym
    rows = rows(1:nnz_sym);
    cols = cols(1:nnz_sym);
    vals = vals(1:nnz_sym);
end

A = sparse(rows, cols, vals, N, m, nnz_sym);

end