function err = LHH_err_LDLT(L1, D1, L2, D2, M, LM)
% Copyright 2020 Tony Stillfjord
%
% This file is part of BST20_CODE.
% 
% BST20_CODE is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% BST20_CODE is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with BST20_CODE.  If not, see <http://www.gnu.org/licenses/>.
%
if nargin < 6
    LM = ichol(M, struct('type','ict','droptol',1e-6));
end

V1 = LM'*L1;
V2 = LM'*L2;
V = [V1, V2]; 
D = blkdiag(D1,-D2);

[~, S] = column_compress_LDLT(V, D, eps);

% Absolute error, norm(D)
err = abs(S(1,1));

% Relative error
[~, S] = column_compress_LDLT(V2, D2, eps);
P2norm = abs(S(1,1));

err = err / P2norm;
    
end
