function LVVnorm = LVV_norm_LDLT(L, D, M, K, LK)
% Supposing X = L*D*L', calculate ||LK'*X*M*/LK'||, corresponding to 
% the L(V,V)-norm of the infinite-dimensional representation of X
%
% Copyright 2020 Tony Stillfjord
%
% This file is part of BST20_CODE.
% 
% BST20_CODE is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% BST20_CODE is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with BST20_CODE.  If not, see <http://www.gnu.org/licenses/>.
%
if nargin < 7
    LK = ichol(-K, struct('type','ict','droptol',1e-6));
end

[~, R1] = qr(LK'*L, 0);
[~, R2] = qr(LK\(M*L), 0);
S = R1*D*R2';

LVVnorm = norm(S);
    
end
