function [NstarA, bdy_ind] = NstarA(FEMdata)
% Compute a matrix representation of the operator N^*A 
% (not used in main code)
%
% Copyright 2020 Tony Stillfjord
%
% This file is part of BST20_CODE.
% 
% BST20_CODE is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% BST20_CODE is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with BST20_CODE.  If not, see <http://www.gnu.org/licenses/>.
%

N1D = sqrt(FEMdata.N);

bottom_ind = fliplr(1:N1D);
right_ind = fliplr(N1D:N1D:N1D^2);
left_ind = 1:N1D:N1D^2;
top_ind = N1D^2 - N1D + 1 : N1D^2;

bdy_ind = [left_ind, top_ind(:, 2:end), right_ind(:, 2:end), bottom_ind(:, 2:end-1)];

NstarA = sparse(1:length(bdy_ind), bdy_ind, ones(length(bdy_ind), 1));
    
end