% Copyright 2020 Tony Stillfjord
%
% This file is part of BST20_CODE.
% 
% BST20_CODE is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% BST20_CODE is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with BST20_CODE.  If not, see <http://www.gnu.org/licenses/>.
%
clear all

Lmax = 7;
data = setup_problem_space(Lmax, true, true); % local

load([data.outputpath, 'results_', int2str(data.Nt(end)), '_', int2str(data.Nx(end)), '.mat'])

%%
dx = data.dx(1:Lmax-1);
figure
loglog(dx, errs_X_abs, '-*k')
hold on
loglog(dx, errs_BX_abs, '-sk')
loglog(dx, dx.^1 * errs_X_abs(end) / dx(end)^1, '--k')
loglog(dx, dx.^2 * errs_X_abs(end) / dx(end)^2, '-k')
legend('$P_{h, \Delta t}$', '$(B^b_h)^*P_{h, \Delta t}$', '$\mathcal{O}(h^1)$', '$\mathcal{O}(h^2)$', 'Location', 'NorthWest','Interpreter','latex')

title('Spatial errors','Interpreter','latex')
xlabel('$h$','Interpreter','latex')
ylabel('Error','Interpreter','latex')
matlab2tikz('fig_DRE_spatial_errors.tex', 'height', '5cm', 'width', '5cm')