% Copyright 2020 Tony Stillfjord
%
% This file is part of BST20_CODE.
% 
% BST20_CODE is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% BST20_CODE is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with BST20_CODE.  If not, see <http://www.gnu.org/licenses/>.
%
clear all

Lmax = 8;
data = setup_problem_time(Lmax, true, true); % local

load([data.outputpath, 'results_', int2str(data.Nt(end)), '_', int2str(data.Nx(end)), '.mat'])

%%
dt = data.dt(1:Lmax-1);
figure
loglog(dt, errs_X_abs, '-*k')
hold on
loglog(dt, errs_BX_abs, '-sk')
loglog(dt, 0.2*dt.^2 * errs_BX_abs(end) / dt(end)^2, '--k')

legend('$P_{h, \Delta t}$', '$(B^b_h)^*P_{h, \Delta t}$', '$\mathcal{O}(dt^2)$', 'Location', 'NorthWest','Interpreter','latex')
  
title('Temporal errors','Interpreter','latex')
xlabel('$\Delta t$','Interpreter','latex')
ylabel('Error','Interpreter','latex')

matlab2tikz('fig_DRE_temporal_errors.tex', 'height', '8cm', 'width', '8cm')