% Copyright 2020 Tony Stillfjord
%
% This file is part of BST20_CODE.
% 
% BST20_CODE is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% BST20_CODE is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with BST20_CODE.  If not, see <http://www.gnu.org/licenses/>.
%
Lmax = 7;
N = 100;
Nbatch = 10;

data = setup_problem_spacetime(Lmax, true, true);

load([data.outputpath, 'results_', int2str(data.Nt(end)), '_', int2str(data.Nx(end)), '.mat'])

%%
dt = data.dt(1:Lmax-1);
figure
loglog(dt, errs_T, '-*k')
hold on
loglog(dt, errsc_T, '-sk')
loglog(dt, 1.25*dt.^.25 * errsc_T(1) / dt(1)^.25, '--k')
loglog(dt, 0.75*dt.^.5 * errsc_T(1) / dt(1)^.5, '-.k')

legend('Uncontrolled $y_{h, \Delta t}$', 'Controlled $y_{h, \Delta t}$', '$\mathcal{O}(\Delta t^{1/4})$', '$\mathcal{O}(\Delta t^{1/2})$', 'Location', 'NorthWest','Interpreter','latex')

xlabel('$\Delta t$','Interpreter','latex')
ylabel('Error','Interpreter','latex')
matlab2tikz('fig_main_errors_temp.tex', 'height', '8cm', 'width', '8cm')