function ns = pointwise_RMS_L2_norm(Z, M)
% Compute at each time step the RMS_L2 norm (i.e. discrete L2 in space, 
% root-mean-square  for the stochasticity, corresponding to discrete expectation)
%
% Copyright 2020 Tony Stillfjord
%
% This file is part of BST20_CODE.
% 
% BST20_CODE is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% BST20_CODE is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with BST20_CODE.  If not, see <http://www.gnu.org/licenses/>.
%
Nx = size(Z, 1);
Nt = size(Z, 2);
N  = size(Z, 3);

ns = zeros(Nt, 1);
for k = 1:Nt
    Zi = reshape(Z(:, k, :), Nx, N);
    ns(k) = RMS_L2_norm(Zi, M);
end


end